
#line 1 "/home/hanzlik/src/rpm/BUILD/rspamd-1.7.0/src/ragel/content_disposition_parser.rl"

#line 94 "/home/hanzlik/src/rpm/BUILD/rspamd-1.7.0/src/ragel/content_disposition_parser.rl"


#include "smtp_parsers.h"
#include "content_type.h"


#line 12 "/home/hanzlik/src/rpm/BUILD/rspamd-1.7.0/src/content_disposition.rl.c"
static const int content_type_parser_start = 1;
static const int content_type_parser_first_final = 15;
static const int content_type_parser_error = 0;

static const int content_type_parser_en_balanced_ccontent = 14;
static const int content_type_parser_en_main = 1;


#line 100 "/home/hanzlik/src/rpm/BUILD/rspamd-1.7.0/src/ragel/content_disposition_parser.rl"

gboolean
rspamd_content_disposition_parser (const char *data, size_t len, struct rspamd_content_disposition *cd, rspamd_mempool_t *pool)
{
  const char *p = data, *pe = data + len, *eof, *qstart = NULL, *qend = NULL,
    *pname_start = NULL, *pname_end = NULL, *pvalue_start = NULL, *pvalue_end = NULL;
  int cs, *stack = NULL;
  gsize top = 0;
  struct _ragel_st_storage {
    int *data;
    gsize size;
  } st_storage;

  memset (&st_storage, 0, sizeof (st_storage));
  memset (cd, 0, sizeof (*cd));
  eof = pe;

  
#line 40 "/home/hanzlik/src/rpm/BUILD/rspamd-1.7.0/src/content_disposition.rl.c"
	{
	cs = content_type_parser_start;
	top = 0;
	}

#line 118 "/home/hanzlik/src/rpm/BUILD/rspamd-1.7.0/src/ragel/content_disposition_parser.rl"
  
#line 48 "/home/hanzlik/src/rpm/BUILD/rspamd-1.7.0/src/content_disposition.rl.c"
	{
	if ( p == pe )
		goto _test_eof;
	goto _resume;

_again:
	switch ( cs ) {
		case 1: goto st1;
		case 0: goto st0;
		case 15: goto st15;
		case 2: goto st2;
		case 3: goto st3;
		case 4: goto st4;
		case 5: goto st5;
		case 16: goto st16;
		case 17: goto st17;
		case 6: goto st6;
		case 7: goto st7;
		case 8: goto st8;
		case 18: goto st18;
		case 9: goto st9;
		case 10: goto st10;
		case 11: goto st11;
		case 12: goto st12;
		case 13: goto st13;
		case 19: goto st19;
		case 20: goto st20;
		case 21: goto st21;
		case 22: goto st22;
		case 23: goto st23;
		case 24: goto st24;
		case 25: goto st25;
		case 26: goto st26;
		case 27: goto st27;
		case 28: goto st28;
		case 29: goto st29;
		case 30: goto st30;
		case 31: goto st31;
		case 32: goto st32;
		case 33: goto st33;
		case 34: goto st34;
		case 14: goto st14;
		case 35: goto st35;
	default: break;
	}

	if ( ++p == pe )
		goto _test_eof;
_resume:
	switch ( cs )
	{
st1:
	if ( ++p == pe )
		goto _test_eof1;
case 1:
	switch( (*p) ) {
		case 97: goto tr2;
		case 105: goto tr3;
	}
	if ( (*p) < 48 ) {
		if ( (*p) > 39 ) {
			if ( 42 <= (*p) && (*p) <= 46 )
				goto tr0;
		} else if ( (*p) >= 33 )
			goto tr0;
	} else if ( (*p) > 57 ) {
		if ( (*p) > 90 ) {
			if ( 94 <= (*p) && (*p) <= 126 )
				goto tr0;
		} else if ( (*p) >= 65 )
			goto tr0;
	} else
		goto tr0;
	goto st0;
st0:
cs = 0;
	goto _out;
tr0:
#line 4 "/home/hanzlik/src/rpm/BUILD/rspamd-1.7.0/src/ragel/content_disposition_parser.rl"
	{
  }
	goto st15;
st15:
	if ( ++p == pe )
		goto _test_eof15;
case 15:
#line 135 "/home/hanzlik/src/rpm/BUILD/rspamd-1.7.0/src/content_disposition.rl.c"
	if ( (*p) == 59 )
		goto tr37;
	if ( (*p) < 48 ) {
		if ( (*p) > 39 ) {
			if ( 42 <= (*p) && (*p) <= 46 )
				goto st15;
		} else if ( (*p) >= 33 )
			goto st15;
	} else if ( (*p) > 57 ) {
		if ( (*p) > 90 ) {
			if ( 94 <= (*p) && (*p) <= 126 )
				goto st15;
		} else if ( (*p) >= 65 )
			goto st15;
	} else
		goto st15;
	goto st0;
tr37:
#line 7 "/home/hanzlik/src/rpm/BUILD/rspamd-1.7.0/src/ragel/content_disposition_parser.rl"
	{
  }
	goto st2;
tr41:
#line 51 "/home/hanzlik/src/rpm/BUILD/rspamd-1.7.0/src/ragel/content_disposition_parser.rl"
	{
    if (pname_end) {
      if (qstart) {
        pvalue_start = qstart;
      }
      if (qend && qend >= qstart) {
        pvalue_end = qend;
      }
      else if (p >= pvalue_start) {
        pvalue_end = p;
      }
      qstart = NULL;
      qend = NULL;

      if (pvalue_end && pvalue_end > pvalue_start && pname_end > pname_start) {
        rspamd_content_disposition_add_param (pool, cd, pname_start, pname_end, pvalue_start, pvalue_end);
      }
    }

    pname_start = NULL;
    pname_end = NULL;
    pvalue_start = NULL;
    pvalue_end = NULL;
    qend = NULL;
    qstart = NULL;
  }
	goto st2;
tr53:
#line 14 "/home/hanzlik/src/rpm/BUILD/rspamd-1.7.0/src/ragel/content_disposition_parser.rl"
	{
    cd->type = RSPAMD_CT_ATTACHMENT;
  }
#line 7 "/home/hanzlik/src/rpm/BUILD/rspamd-1.7.0/src/ragel/content_disposition_parser.rl"
	{
  }
	goto st2;
tr59:
#line 10 "/home/hanzlik/src/rpm/BUILD/rspamd-1.7.0/src/ragel/content_disposition_parser.rl"
	{
    cd->type = RSPAMD_CT_INLINE;
  }
#line 7 "/home/hanzlik/src/rpm/BUILD/rspamd-1.7.0/src/ragel/content_disposition_parser.rl"
	{
  }
	goto st2;
st2:
	if ( ++p == pe )
		goto _test_eof2;
case 2:
#line 209 "/home/hanzlik/src/rpm/BUILD/rspamd-1.7.0/src/content_disposition.rl.c"
	switch( (*p) ) {
		case 32: goto st2;
		case 40: goto st13;
	}
	if ( (*p) < 48 ) {
		if ( (*p) > 39 ) {
			if ( 42 <= (*p) && (*p) <= 46 )
				goto tr5;
		} else if ( (*p) >= 33 )
			goto tr5;
	} else if ( (*p) > 57 ) {
		if ( (*p) > 90 ) {
			if ( 94 <= (*p) && (*p) <= 126 )
				goto tr5;
		} else if ( (*p) >= 65 )
			goto tr5;
	} else
		goto tr5;
	goto st0;
tr5:
#line 18 "/home/hanzlik/src/rpm/BUILD/rspamd-1.7.0/src/ragel/content_disposition_parser.rl"
	{
    qstart = NULL;
    qend = NULL;
    pname_start = p;
    pname_end = NULL;
  }
	goto st3;
st3:
	if ( ++p == pe )
		goto _test_eof3;
case 3:
#line 242 "/home/hanzlik/src/rpm/BUILD/rspamd-1.7.0/src/content_disposition.rl.c"
	switch( (*p) ) {
		case 32: goto tr7;
		case 61: goto tr9;
	}
	if ( (*p) < 48 ) {
		if ( (*p) > 39 ) {
			if ( 42 <= (*p) && (*p) <= 46 )
				goto st3;
		} else if ( (*p) >= 33 )
			goto st3;
	} else if ( (*p) > 57 ) {
		if ( (*p) > 90 ) {
			if ( 94 <= (*p) && (*p) <= 126 )
				goto st3;
		} else if ( (*p) >= 65 )
			goto st3;
	} else
		goto st3;
	goto st0;
tr7:
#line 25 "/home/hanzlik/src/rpm/BUILD/rspamd-1.7.0/src/ragel/content_disposition_parser.rl"
	{
    if (qstart) {
      pname_start = qstart;
    }
    if (qend && qend >= qstart) {
      pname_end = qend;
    }
    else if (p >= pname_start) {
      pname_end = p;
    }
    qstart = NULL;
    qend = NULL;
  }
	goto st4;
st4:
	if ( ++p == pe )
		goto _test_eof4;
case 4:
#line 282 "/home/hanzlik/src/rpm/BUILD/rspamd-1.7.0/src/content_disposition.rl.c"
	switch( (*p) ) {
		case 32: goto st4;
		case 61: goto st5;
	}
	goto st0;
tr9:
#line 25 "/home/hanzlik/src/rpm/BUILD/rspamd-1.7.0/src/ragel/content_disposition_parser.rl"
	{
    if (qstart) {
      pname_start = qstart;
    }
    if (qend && qend >= qstart) {
      pname_end = qend;
    }
    else if (p >= pname_start) {
      pname_end = p;
    }
    qstart = NULL;
    qend = NULL;
  }
	goto st5;
tr12:
#line 40 "/home/hanzlik/src/rpm/BUILD/rspamd-1.7.0/src/ragel/content_disposition_parser.rl"
	{
    qstart = NULL;
    qend = NULL;

    if (pname_end) {
      pvalue_start = p;
      pvalue_end = NULL;
    }
  }
	goto st5;
st5:
	if ( ++p == pe )
		goto _test_eof5;
case 5:
#line 320 "/home/hanzlik/src/rpm/BUILD/rspamd-1.7.0/src/content_disposition.rl.c"
	switch( (*p) ) {
		case 32: goto tr12;
		case 34: goto tr14;
		case 40: goto tr15;
		case 61: goto tr13;
	}
	if ( (*p) < 48 ) {
		if ( (*p) > 39 ) {
			if ( 42 <= (*p) && (*p) <= 46 )
				goto tr13;
		} else if ( (*p) >= 33 )
			goto tr13;
	} else if ( (*p) > 57 ) {
		if ( (*p) > 90 ) {
			if ( 94 <= (*p) && (*p) <= 126 )
				goto tr13;
		} else if ( (*p) >= 65 )
			goto tr13;
	} else
		goto tr13;
	goto st0;
tr13:
#line 40 "/home/hanzlik/src/rpm/BUILD/rspamd-1.7.0/src/ragel/content_disposition_parser.rl"
	{
    qstart = NULL;
    qend = NULL;

    if (pname_end) {
      pvalue_start = p;
      pvalue_end = NULL;
    }
  }
	goto st16;
st16:
	if ( ++p == pe )
		goto _test_eof16;
case 16:
#line 358 "/home/hanzlik/src/rpm/BUILD/rspamd-1.7.0/src/content_disposition.rl.c"
	switch( (*p) ) {
		case 32: goto tr38;
		case 33: goto st16;
		case 40: goto tr40;
		case 59: goto tr41;
		case 61: goto st16;
	}
	if ( (*p) < 48 ) {
		if ( (*p) > 39 ) {
			if ( 42 <= (*p) && (*p) <= 46 )
				goto st16;
		} else if ( (*p) >= 35 )
			goto st16;
	} else if ( (*p) > 57 ) {
		if ( (*p) > 90 ) {
			if ( 94 <= (*p) && (*p) <= 126 )
				goto st16;
		} else if ( (*p) >= 65 )
			goto st16;
	} else
		goto st16;
	goto st0;
tr38:
#line 51 "/home/hanzlik/src/rpm/BUILD/rspamd-1.7.0/src/ragel/content_disposition_parser.rl"
	{
    if (pname_end) {
      if (qstart) {
        pvalue_start = qstart;
      }
      if (qend && qend >= qstart) {
        pvalue_end = qend;
      }
      else if (p >= pvalue_start) {
        pvalue_end = p;
      }
      qstart = NULL;
      qend = NULL;

      if (pvalue_end && pvalue_end > pvalue_start && pname_end > pname_start) {
        rspamd_content_disposition_add_param (pool, cd, pname_start, pname_end, pvalue_start, pvalue_end);
      }
    }

    pname_start = NULL;
    pname_end = NULL;
    pvalue_start = NULL;
    pvalue_end = NULL;
    qend = NULL;
    qstart = NULL;
  }
	goto st17;
st17:
	if ( ++p == pe )
		goto _test_eof17;
case 17:
#line 414 "/home/hanzlik/src/rpm/BUILD/rspamd-1.7.0/src/content_disposition.rl.c"
	switch( (*p) ) {
		case 32: goto st17;
		case 40: goto st6;
		case 59: goto st2;
	}
	goto st0;
tr17:
#line 7 "/home/hanzlik/src/rpm/BUILD/rspamd-1.7.0/src/ragel/content_disposition.rl"
	{ {
    if (top >= st_storage.size) {
      st_storage.size = (top + 1) * 2;
      st_storage.data = realloc (st_storage.data, st_storage.size * sizeof (int));
      g_assert (st_storage.data != NULL);
      stack = st_storage.data;
    }
  {stack[top++] = 6;goto st14;}} }
	goto st6;
tr40:
#line 51 "/home/hanzlik/src/rpm/BUILD/rspamd-1.7.0/src/ragel/content_disposition_parser.rl"
	{
    if (pname_end) {
      if (qstart) {
        pvalue_start = qstart;
      }
      if (qend && qend >= qstart) {
        pvalue_end = qend;
      }
      else if (p >= pvalue_start) {
        pvalue_end = p;
      }
      qstart = NULL;
      qend = NULL;

      if (pvalue_end && pvalue_end > pvalue_start && pname_end > pname_start) {
        rspamd_content_disposition_add_param (pool, cd, pname_start, pname_end, pvalue_start, pvalue_end);
      }
    }

    pname_start = NULL;
    pname_end = NULL;
    pvalue_start = NULL;
    pvalue_end = NULL;
    qend = NULL;
    qstart = NULL;
  }
	goto st6;
st6:
	if ( ++p == pe )
		goto _test_eof6;
case 6:
#line 465 "/home/hanzlik/src/rpm/BUILD/rspamd-1.7.0/src/content_disposition.rl.c"
	switch( (*p) ) {
		case 40: goto tr17;
		case 41: goto st17;
	}
	if ( (*p) > 91 ) {
		if ( 93 <= (*p) && (*p) <= 126 )
			goto st6;
	} else if ( (*p) >= 32 )
		goto st6;
	goto st0;
tr14:
#line 40 "/home/hanzlik/src/rpm/BUILD/rspamd-1.7.0/src/ragel/content_disposition_parser.rl"
	{
    qstart = NULL;
    qend = NULL;

    if (pname_end) {
      pvalue_start = p;
      pvalue_end = NULL;
    }
  }
	goto st7;
st7:
	if ( ++p == pe )
		goto _test_eof7;
case 7:
#line 492 "/home/hanzlik/src/rpm/BUILD/rspamd-1.7.0/src/content_disposition.rl.c"
	switch( (*p) ) {
		case 34: goto tr20;
		case 92: goto tr21;
	}
	if ( 32 <= (*p) && (*p) <= 126 )
		goto tr19;
	goto st0;
tr19:
#line 78 "/home/hanzlik/src/rpm/BUILD/rspamd-1.7.0/src/ragel/content_disposition_parser.rl"
	{
    qstart = p;
    qend = NULL;
  }
	goto st8;
st8:
	if ( ++p == pe )
		goto _test_eof8;
case 8:
#line 511 "/home/hanzlik/src/rpm/BUILD/rspamd-1.7.0/src/content_disposition.rl.c"
	switch( (*p) ) {
		case 34: goto tr23;
		case 92: goto st10;
	}
	if ( 32 <= (*p) && (*p) <= 126 )
		goto st8;
	goto st0;
tr20:
#line 78 "/home/hanzlik/src/rpm/BUILD/rspamd-1.7.0/src/ragel/content_disposition_parser.rl"
	{
    qstart = p;
    qend = NULL;
  }
#line 83 "/home/hanzlik/src/rpm/BUILD/rspamd-1.7.0/src/ragel/content_disposition_parser.rl"
	{
    if (qstart) {
      qend = p;
    }
  }
	goto st18;
tr23:
#line 83 "/home/hanzlik/src/rpm/BUILD/rspamd-1.7.0/src/ragel/content_disposition_parser.rl"
	{
    if (qstart) {
      qend = p;
    }
  }
	goto st18;
tr42:
#line 51 "/home/hanzlik/src/rpm/BUILD/rspamd-1.7.0/src/ragel/content_disposition_parser.rl"
	{
    if (pname_end) {
      if (qstart) {
        pvalue_start = qstart;
      }
      if (qend && qend >= qstart) {
        pvalue_end = qend;
      }
      else if (p >= pvalue_start) {
        pvalue_end = p;
      }
      qstart = NULL;
      qend = NULL;

      if (pvalue_end && pvalue_end > pvalue_start && pname_end > pname_start) {
        rspamd_content_disposition_add_param (pool, cd, pname_start, pname_end, pvalue_start, pvalue_end);
      }
    }

    pname_start = NULL;
    pname_end = NULL;
    pvalue_start = NULL;
    pvalue_end = NULL;
    qend = NULL;
    qstart = NULL;
  }
	goto st18;
st18:
	if ( ++p == pe )
		goto _test_eof18;
case 18:
#line 573 "/home/hanzlik/src/rpm/BUILD/rspamd-1.7.0/src/content_disposition.rl.c"
	switch( (*p) ) {
		case 32: goto tr42;
		case 40: goto tr43;
		case 59: goto tr41;
	}
	goto st0;
tr26:
#line 7 "/home/hanzlik/src/rpm/BUILD/rspamd-1.7.0/src/ragel/content_disposition.rl"
	{ {
    if (top >= st_storage.size) {
      st_storage.size = (top + 1) * 2;
      st_storage.data = realloc (st_storage.data, st_storage.size * sizeof (int));
      g_assert (st_storage.data != NULL);
      stack = st_storage.data;
    }
  {stack[top++] = 9;goto st14;}} }
	goto st9;
tr43:
#line 51 "/home/hanzlik/src/rpm/BUILD/rspamd-1.7.0/src/ragel/content_disposition_parser.rl"
	{
    if (pname_end) {
      if (qstart) {
        pvalue_start = qstart;
      }
      if (qend && qend >= qstart) {
        pvalue_end = qend;
      }
      else if (p >= pvalue_start) {
        pvalue_end = p;
      }
      qstart = NULL;
      qend = NULL;

      if (pvalue_end && pvalue_end > pvalue_start && pname_end > pname_start) {
        rspamd_content_disposition_add_param (pool, cd, pname_start, pname_end, pvalue_start, pvalue_end);
      }
    }

    pname_start = NULL;
    pname_end = NULL;
    pvalue_start = NULL;
    pvalue_end = NULL;
    qend = NULL;
    qstart = NULL;
  }
	goto st9;
st9:
	if ( ++p == pe )
		goto _test_eof9;
case 9:
#line 624 "/home/hanzlik/src/rpm/BUILD/rspamd-1.7.0/src/content_disposition.rl.c"
	switch( (*p) ) {
		case 40: goto tr26;
		case 41: goto st18;
	}
	if ( (*p) > 91 ) {
		if ( 93 <= (*p) && (*p) <= 126 )
			goto st9;
	} else if ( (*p) >= 32 )
		goto st9;
	goto st0;
tr21:
#line 78 "/home/hanzlik/src/rpm/BUILD/rspamd-1.7.0/src/ragel/content_disposition_parser.rl"
	{
    qstart = p;
    qend = NULL;
  }
	goto st10;
st10:
	if ( ++p == pe )
		goto _test_eof10;
case 10:
#line 646 "/home/hanzlik/src/rpm/BUILD/rspamd-1.7.0/src/content_disposition.rl.c"
	if ( 32 <= (*p) && (*p) <= 126 )
		goto st8;
	goto st0;
tr15:
#line 40 "/home/hanzlik/src/rpm/BUILD/rspamd-1.7.0/src/ragel/content_disposition_parser.rl"
	{
    qstart = NULL;
    qend = NULL;

    if (pname_end) {
      pvalue_start = p;
      pvalue_end = NULL;
    }
  }
	goto st11;
tr29:
#line 7 "/home/hanzlik/src/rpm/BUILD/rspamd-1.7.0/src/ragel/content_disposition.rl"
	{ {
    if (top >= st_storage.size) {
      st_storage.size = (top + 1) * 2;
      st_storage.data = realloc (st_storage.data, st_storage.size * sizeof (int));
      g_assert (st_storage.data != NULL);
      stack = st_storage.data;
    }
  {stack[top++] = 11;goto st14;}} }
	goto st11;
st11:
	if ( ++p == pe )
		goto _test_eof11;
case 11:
#line 677 "/home/hanzlik/src/rpm/BUILD/rspamd-1.7.0/src/content_disposition.rl.c"
	switch( (*p) ) {
		case 40: goto tr29;
		case 41: goto st12;
	}
	if ( (*p) > 91 ) {
		if ( 93 <= (*p) && (*p) <= 126 )
			goto st11;
	} else if ( (*p) >= 32 )
		goto st11;
	goto st0;
st12:
	if ( ++p == pe )
		goto _test_eof12;
case 12:
	switch( (*p) ) {
		case 32: goto st12;
		case 34: goto st7;
		case 40: goto st11;
	}
	goto st0;
tr32:
#line 7 "/home/hanzlik/src/rpm/BUILD/rspamd-1.7.0/src/ragel/content_disposition.rl"
	{ {
    if (top >= st_storage.size) {
      st_storage.size = (top + 1) * 2;
      st_storage.data = realloc (st_storage.data, st_storage.size * sizeof (int));
      g_assert (st_storage.data != NULL);
      stack = st_storage.data;
    }
  {stack[top++] = 13;goto st14;}} }
	goto st13;
st13:
	if ( ++p == pe )
		goto _test_eof13;
case 13:
#line 713 "/home/hanzlik/src/rpm/BUILD/rspamd-1.7.0/src/content_disposition.rl.c"
	switch( (*p) ) {
		case 40: goto tr32;
		case 41: goto st2;
	}
	if ( (*p) > 91 ) {
		if ( 93 <= (*p) && (*p) <= 126 )
			goto st13;
	} else if ( (*p) >= 32 )
		goto st13;
	goto st0;
tr2:
#line 4 "/home/hanzlik/src/rpm/BUILD/rspamd-1.7.0/src/ragel/content_disposition_parser.rl"
	{
  }
	goto st19;
st19:
	if ( ++p == pe )
		goto _test_eof19;
case 19:
#line 733 "/home/hanzlik/src/rpm/BUILD/rspamd-1.7.0/src/content_disposition.rl.c"
	switch( (*p) ) {
		case 59: goto tr37;
		case 116: goto st20;
	}
	if ( (*p) < 48 ) {
		if ( (*p) > 39 ) {
			if ( 42 <= (*p) && (*p) <= 46 )
				goto st15;
		} else if ( (*p) >= 33 )
			goto st15;
	} else if ( (*p) > 57 ) {
		if ( (*p) > 90 ) {
			if ( 94 <= (*p) && (*p) <= 126 )
				goto st15;
		} else if ( (*p) >= 65 )
			goto st15;
	} else
		goto st15;
	goto st0;
st20:
	if ( ++p == pe )
		goto _test_eof20;
case 20:
	switch( (*p) ) {
		case 59: goto tr37;
		case 116: goto st21;
	}
	if ( (*p) < 48 ) {
		if ( (*p) > 39 ) {
			if ( 42 <= (*p) && (*p) <= 46 )
				goto st15;
		} else if ( (*p) >= 33 )
			goto st15;
	} else if ( (*p) > 57 ) {
		if ( (*p) > 90 ) {
			if ( 94 <= (*p) && (*p) <= 126 )
				goto st15;
		} else if ( (*p) >= 65 )
			goto st15;
	} else
		goto st15;
	goto st0;
st21:
	if ( ++p == pe )
		goto _test_eof21;
case 21:
	switch( (*p) ) {
		case 59: goto tr37;
		case 97: goto st22;
	}
	if ( (*p) < 48 ) {
		if ( (*p) > 39 ) {
			if ( 42 <= (*p) && (*p) <= 46 )
				goto st15;
		} else if ( (*p) >= 33 )
			goto st15;
	} else if ( (*p) > 57 ) {
		if ( (*p) > 90 ) {
			if ( 94 <= (*p) && (*p) <= 126 )
				goto st15;
		} else if ( (*p) >= 65 )
			goto st15;
	} else
		goto st15;
	goto st0;
st22:
	if ( ++p == pe )
		goto _test_eof22;
case 22:
	switch( (*p) ) {
		case 59: goto tr37;
		case 99: goto st23;
	}
	if ( (*p) < 48 ) {
		if ( (*p) > 39 ) {
			if ( 42 <= (*p) && (*p) <= 46 )
				goto st15;
		} else if ( (*p) >= 33 )
			goto st15;
	} else if ( (*p) > 57 ) {
		if ( (*p) > 90 ) {
			if ( 94 <= (*p) && (*p) <= 126 )
				goto st15;
		} else if ( (*p) >= 65 )
			goto st15;
	} else
		goto st15;
	goto st0;
st23:
	if ( ++p == pe )
		goto _test_eof23;
case 23:
	switch( (*p) ) {
		case 59: goto tr37;
		case 104: goto st24;
	}
	if ( (*p) < 48 ) {
		if ( (*p) > 39 ) {
			if ( 42 <= (*p) && (*p) <= 46 )
				goto st15;
		} else if ( (*p) >= 33 )
			goto st15;
	} else if ( (*p) > 57 ) {
		if ( (*p) > 90 ) {
			if ( 94 <= (*p) && (*p) <= 126 )
				goto st15;
		} else if ( (*p) >= 65 )
			goto st15;
	} else
		goto st15;
	goto st0;
st24:
	if ( ++p == pe )
		goto _test_eof24;
case 24:
	switch( (*p) ) {
		case 59: goto tr37;
		case 109: goto st25;
	}
	if ( (*p) < 48 ) {
		if ( (*p) > 39 ) {
			if ( 42 <= (*p) && (*p) <= 46 )
				goto st15;
		} else if ( (*p) >= 33 )
			goto st15;
	} else if ( (*p) > 57 ) {
		if ( (*p) > 90 ) {
			if ( 94 <= (*p) && (*p) <= 126 )
				goto st15;
		} else if ( (*p) >= 65 )
			goto st15;
	} else
		goto st15;
	goto st0;
st25:
	if ( ++p == pe )
		goto _test_eof25;
case 25:
	switch( (*p) ) {
		case 59: goto tr37;
		case 101: goto st26;
	}
	if ( (*p) < 48 ) {
		if ( (*p) > 39 ) {
			if ( 42 <= (*p) && (*p) <= 46 )
				goto st15;
		} else if ( (*p) >= 33 )
			goto st15;
	} else if ( (*p) > 57 ) {
		if ( (*p) > 90 ) {
			if ( 94 <= (*p) && (*p) <= 126 )
				goto st15;
		} else if ( (*p) >= 65 )
			goto st15;
	} else
		goto st15;
	goto st0;
st26:
	if ( ++p == pe )
		goto _test_eof26;
case 26:
	switch( (*p) ) {
		case 59: goto tr37;
		case 110: goto st27;
	}
	if ( (*p) < 48 ) {
		if ( (*p) > 39 ) {
			if ( 42 <= (*p) && (*p) <= 46 )
				goto st15;
		} else if ( (*p) >= 33 )
			goto st15;
	} else if ( (*p) > 57 ) {
		if ( (*p) > 90 ) {
			if ( 94 <= (*p) && (*p) <= 126 )
				goto st15;
		} else if ( (*p) >= 65 )
			goto st15;
	} else
		goto st15;
	goto st0;
st27:
	if ( ++p == pe )
		goto _test_eof27;
case 27:
	switch( (*p) ) {
		case 59: goto tr37;
		case 116: goto st28;
	}
	if ( (*p) < 48 ) {
		if ( (*p) > 39 ) {
			if ( 42 <= (*p) && (*p) <= 46 )
				goto st15;
		} else if ( (*p) >= 33 )
			goto st15;
	} else if ( (*p) > 57 ) {
		if ( (*p) > 90 ) {
			if ( 94 <= (*p) && (*p) <= 126 )
				goto st15;
		} else if ( (*p) >= 65 )
			goto st15;
	} else
		goto st15;
	goto st0;
st28:
	if ( ++p == pe )
		goto _test_eof28;
case 28:
	if ( (*p) == 59 )
		goto tr53;
	if ( (*p) < 48 ) {
		if ( (*p) > 39 ) {
			if ( 42 <= (*p) && (*p) <= 46 )
				goto st15;
		} else if ( (*p) >= 33 )
			goto st15;
	} else if ( (*p) > 57 ) {
		if ( (*p) > 90 ) {
			if ( 94 <= (*p) && (*p) <= 126 )
				goto st15;
		} else if ( (*p) >= 65 )
			goto st15;
	} else
		goto st15;
	goto st0;
tr3:
#line 4 "/home/hanzlik/src/rpm/BUILD/rspamd-1.7.0/src/ragel/content_disposition_parser.rl"
	{
  }
	goto st29;
st29:
	if ( ++p == pe )
		goto _test_eof29;
case 29:
#line 967 "/home/hanzlik/src/rpm/BUILD/rspamd-1.7.0/src/content_disposition.rl.c"
	switch( (*p) ) {
		case 59: goto tr37;
		case 110: goto st30;
	}
	if ( (*p) < 48 ) {
		if ( (*p) > 39 ) {
			if ( 42 <= (*p) && (*p) <= 46 )
				goto st15;
		} else if ( (*p) >= 33 )
			goto st15;
	} else if ( (*p) > 57 ) {
		if ( (*p) > 90 ) {
			if ( 94 <= (*p) && (*p) <= 126 )
				goto st15;
		} else if ( (*p) >= 65 )
			goto st15;
	} else
		goto st15;
	goto st0;
st30:
	if ( ++p == pe )
		goto _test_eof30;
case 30:
	switch( (*p) ) {
		case 59: goto tr37;
		case 108: goto st31;
	}
	if ( (*p) < 48 ) {
		if ( (*p) > 39 ) {
			if ( 42 <= (*p) && (*p) <= 46 )
				goto st15;
		} else if ( (*p) >= 33 )
			goto st15;
	} else if ( (*p) > 57 ) {
		if ( (*p) > 90 ) {
			if ( 94 <= (*p) && (*p) <= 126 )
				goto st15;
		} else if ( (*p) >= 65 )
			goto st15;
	} else
		goto st15;
	goto st0;
st31:
	if ( ++p == pe )
		goto _test_eof31;
case 31:
	switch( (*p) ) {
		case 59: goto tr37;
		case 105: goto st32;
	}
	if ( (*p) < 48 ) {
		if ( (*p) > 39 ) {
			if ( 42 <= (*p) && (*p) <= 46 )
				goto st15;
		} else if ( (*p) >= 33 )
			goto st15;
	} else if ( (*p) > 57 ) {
		if ( (*p) > 90 ) {
			if ( 94 <= (*p) && (*p) <= 126 )
				goto st15;
		} else if ( (*p) >= 65 )
			goto st15;
	} else
		goto st15;
	goto st0;
st32:
	if ( ++p == pe )
		goto _test_eof32;
case 32:
	switch( (*p) ) {
		case 59: goto tr37;
		case 110: goto st33;
	}
	if ( (*p) < 48 ) {
		if ( (*p) > 39 ) {
			if ( 42 <= (*p) && (*p) <= 46 )
				goto st15;
		} else if ( (*p) >= 33 )
			goto st15;
	} else if ( (*p) > 57 ) {
		if ( (*p) > 90 ) {
			if ( 94 <= (*p) && (*p) <= 126 )
				goto st15;
		} else if ( (*p) >= 65 )
			goto st15;
	} else
		goto st15;
	goto st0;
st33:
	if ( ++p == pe )
		goto _test_eof33;
case 33:
	switch( (*p) ) {
		case 59: goto tr37;
		case 101: goto st34;
	}
	if ( (*p) < 48 ) {
		if ( (*p) > 39 ) {
			if ( 42 <= (*p) && (*p) <= 46 )
				goto st15;
		} else if ( (*p) >= 33 )
			goto st15;
	} else if ( (*p) > 57 ) {
		if ( (*p) > 90 ) {
			if ( 94 <= (*p) && (*p) <= 126 )
				goto st15;
		} else if ( (*p) >= 65 )
			goto st15;
	} else
		goto st15;
	goto st0;
st34:
	if ( ++p == pe )
		goto _test_eof34;
case 34:
	if ( (*p) == 59 )
		goto tr59;
	if ( (*p) < 48 ) {
		if ( (*p) > 39 ) {
			if ( 42 <= (*p) && (*p) <= 46 )
				goto st15;
		} else if ( (*p) >= 33 )
			goto st15;
	} else if ( (*p) > 57 ) {
		if ( (*p) > 90 ) {
			if ( 94 <= (*p) && (*p) <= 126 )
				goto st15;
		} else if ( (*p) >= 65 )
			goto st15;
	} else
		goto st15;
	goto st0;
tr34:
#line 7 "/home/hanzlik/src/rpm/BUILD/rspamd-1.7.0/src/ragel/content_disposition.rl"
	{ {
    if (top >= st_storage.size) {
      st_storage.size = (top + 1) * 2;
      st_storage.data = realloc (st_storage.data, st_storage.size * sizeof (int));
      g_assert (st_storage.data != NULL);
      stack = st_storage.data;
    }
  {stack[top++] = 14;goto st14;}} }
	goto st14;
st14:
	if ( ++p == pe )
		goto _test_eof14;
case 14:
#line 1115 "/home/hanzlik/src/rpm/BUILD/rspamd-1.7.0/src/content_disposition.rl.c"
	switch( (*p) ) {
		case 40: goto tr34;
		case 41: goto tr35;
	}
	if ( (*p) > 91 ) {
		if ( 93 <= (*p) && (*p) <= 126 )
			goto st14;
	} else if ( (*p) >= 32 )
		goto st14;
	goto st0;
tr35:
#line 8 "/home/hanzlik/src/rpm/BUILD/rspamd-1.7.0/src/ragel/content_disposition.rl"
	{ {cs = stack[--top];goto _again;} }
	goto st35;
st35:
	if ( ++p == pe )
		goto _test_eof35;
case 35:
#line 1134 "/home/hanzlik/src/rpm/BUILD/rspamd-1.7.0/src/content_disposition.rl.c"
	goto st0;
	}
	_test_eof1: cs = 1; goto _test_eof; 
	_test_eof15: cs = 15; goto _test_eof; 
	_test_eof2: cs = 2; goto _test_eof; 
	_test_eof3: cs = 3; goto _test_eof; 
	_test_eof4: cs = 4; goto _test_eof; 
	_test_eof5: cs = 5; goto _test_eof; 
	_test_eof16: cs = 16; goto _test_eof; 
	_test_eof17: cs = 17; goto _test_eof; 
	_test_eof6: cs = 6; goto _test_eof; 
	_test_eof7: cs = 7; goto _test_eof; 
	_test_eof8: cs = 8; goto _test_eof; 
	_test_eof18: cs = 18; goto _test_eof; 
	_test_eof9: cs = 9; goto _test_eof; 
	_test_eof10: cs = 10; goto _test_eof; 
	_test_eof11: cs = 11; goto _test_eof; 
	_test_eof12: cs = 12; goto _test_eof; 
	_test_eof13: cs = 13; goto _test_eof; 
	_test_eof19: cs = 19; goto _test_eof; 
	_test_eof20: cs = 20; goto _test_eof; 
	_test_eof21: cs = 21; goto _test_eof; 
	_test_eof22: cs = 22; goto _test_eof; 
	_test_eof23: cs = 23; goto _test_eof; 
	_test_eof24: cs = 24; goto _test_eof; 
	_test_eof25: cs = 25; goto _test_eof; 
	_test_eof26: cs = 26; goto _test_eof; 
	_test_eof27: cs = 27; goto _test_eof; 
	_test_eof28: cs = 28; goto _test_eof; 
	_test_eof29: cs = 29; goto _test_eof; 
	_test_eof30: cs = 30; goto _test_eof; 
	_test_eof31: cs = 31; goto _test_eof; 
	_test_eof32: cs = 32; goto _test_eof; 
	_test_eof33: cs = 33; goto _test_eof; 
	_test_eof34: cs = 34; goto _test_eof; 
	_test_eof14: cs = 14; goto _test_eof; 
	_test_eof35: cs = 35; goto _test_eof; 

	_test_eof: {}
	if ( p == eof )
	{
	switch ( cs ) {
	case 15: 
	case 19: 
	case 20: 
	case 21: 
	case 22: 
	case 23: 
	case 24: 
	case 25: 
	case 26: 
	case 27: 
	case 29: 
	case 30: 
	case 31: 
	case 32: 
	case 33: 
#line 7 "/home/hanzlik/src/rpm/BUILD/rspamd-1.7.0/src/ragel/content_disposition_parser.rl"
	{
  }
	break;
	case 16: 
	case 18: 
#line 51 "/home/hanzlik/src/rpm/BUILD/rspamd-1.7.0/src/ragel/content_disposition_parser.rl"
	{
    if (pname_end) {
      if (qstart) {
        pvalue_start = qstart;
      }
      if (qend && qend >= qstart) {
        pvalue_end = qend;
      }
      else if (p >= pvalue_start) {
        pvalue_end = p;
      }
      qstart = NULL;
      qend = NULL;

      if (pvalue_end && pvalue_end > pvalue_start && pname_end > pname_start) {
        rspamd_content_disposition_add_param (pool, cd, pname_start, pname_end, pvalue_start, pvalue_end);
      }
    }

    pname_start = NULL;
    pname_end = NULL;
    pvalue_start = NULL;
    pvalue_end = NULL;
    qend = NULL;
    qstart = NULL;
  }
	break;
	case 34: 
#line 10 "/home/hanzlik/src/rpm/BUILD/rspamd-1.7.0/src/ragel/content_disposition_parser.rl"
	{
    cd->type = RSPAMD_CT_INLINE;
  }
#line 7 "/home/hanzlik/src/rpm/BUILD/rspamd-1.7.0/src/ragel/content_disposition_parser.rl"
	{
  }
	break;
	case 28: 
#line 14 "/home/hanzlik/src/rpm/BUILD/rspamd-1.7.0/src/ragel/content_disposition_parser.rl"
	{
    cd->type = RSPAMD_CT_ATTACHMENT;
  }
#line 7 "/home/hanzlik/src/rpm/BUILD/rspamd-1.7.0/src/ragel/content_disposition_parser.rl"
	{
  }
	break;
#line 1244 "/home/hanzlik/src/rpm/BUILD/rspamd-1.7.0/src/content_disposition.rl.c"
	}
	}

	_out: {}
	}

#line 119 "/home/hanzlik/src/rpm/BUILD/rspamd-1.7.0/src/ragel/content_disposition_parser.rl"

  if (st_storage.data) {
    free (st_storage.data);
  }

  return cd->type != RSPAMD_CT_UNKNOWN;
}
